---
title: List all customers
slug: reference/list-all-customers
docTags: 
createdAt: 2025-10-28T20:08:37.011Z
---

{
  "id": "o0_NcoSlS8it6jFAMmQiJ",
  "type": "api-oas-v2",
  "data": {
    "method": "GET",
    "url": "https://app.amberflo.io/customers",
    "servers": [
      {
        "url": "https://app.amberflo.io/customers"
      }
    ],
    "name": "List all customers",
    "description": "<p>Retrieves all customers in your account without pagination or filtering.\nUse this endpoint when you need the complete list of customers for bulk operations or exports.</p>\n<p>For large customer bases, consider using the <code>/customers/paging</code> endpoint instead, which provides pagination, filtering, and search capabilities.</p>\n<p><strong>Important Note:</strong> This endpoint returns all customers at once, which may impact performance for accounts with thousands of customers.</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [],
      "queryParameters": [],
      "bodyDataParameters": [],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "apiKey",
          "name": "X-API-KEY",
          "kind": "optional",
          "type": "apiKey",
          "in": "header"
        }
      ]
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "Successfully retrieved all customer records from your account",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "array",
            "description": "Complete customer record with system-generated fields and timestamps.",
            "customType": "customer.CustomerDetails.out[]",
            "schema": [
              {
                "name": "createTime",
                "kind": "optional",
                "type": "integer<int64>",
                "description": "Creation time in [Unix time](https://en.wikipedia.org/wiki/Unix_time) (milliseconds)",
                "example": 0
              },
              {
                "name": "updateTime",
                "kind": "optional",
                "type": "integer<int64>",
                "description": "Update time in [Unix time](https://en.wikipedia.org/wiki/Unix_time) (milliseconds)",
                "example": 0
              },
              {
                "name": "deleteTime",
                "kind": "optional",
                "type": "integer<int64>",
                "description": "Timestamp when the customer was deleted, in Unix time (milliseconds). Null if not deleted.",
                "example": 0
              },
              {
                "name": "customerId",
                "kind": "required",
                "type": "string",
                "description": "Id of the customer, as it exists in your system.",
                "example": ""
              },
              {
                "name": "customerName",
                "kind": "required",
                "type": "string",
                "description": "Name of the customer, as it exists in your system.",
                "example": ""
              },
              {
                "name": "customerEmail",
                "kind": "optional",
                "type": "string",
                "description": "Email of the customer, as it exists in your system.",
                "example": ""
              },
              {
                "name": "description",
                "kind": "optional",
                "type": "string",
                "description": "Description of the customer.",
                "example": ""
              },
              {
                "name": "enabled",
                "kind": "optional",
                "type": "boolean",
                "deprecated": true,
                "description": "Warning: Deprecated\nDetermines whether the customer is active or not. Setting it to false deactivates the customer. Only relevant when updating a customer.\n\nNote that this field is superseded by the `lifecycleStage` one, which allows finer grained control. When `enabled = false` means `lifecycleStage = OFFBOARDED`, other lifecycle stages mean `enabled = true` and vice-versa.",
                "example": ""
              },
              {
                "name": "test",
                "kind": "optional",
                "type": "boolean",
                "description": "Determines whether the customer is a test customer. Can only be set once during creation. Test customers can be excluded from certain operations.\n\nDefaults to `false`.",
                "example": ""
              },
              {
                "name": "lifecycleStage",
                "kind": "optional",
                "type": "string",
                "description": "The lifecycle stage of a customer. The lifecycle stage of a customer determines which features of the system are enabled for it.\n\nValid lifecycle stages are:\n- `ONBOARDING` - Only usage is tracked.\n- `TRAIL` - Both usage and billing data are tracked but customer will not be charged.\n- `ACTIVE` - Both usage and billing data are tracked and customer will be charged.\n- `OFFBOARDED` - Only usage is tracked.\n\nDefault: `ACTIVE`",
                "modelRef": "#/components/schemas/customer.CustomerLifecycleStage.out",
                "customType": "customer.CustomerLifecycleStage.out",
                "schema": []
              },
              {
                "name": "deactivateTimeStamp",
                "kind": "optional",
                "type": "integer<int64>",
                "description": "Timestamp when the customer was last deactivated, in Unix time (milliseconds).",
                "example": 0
              },
              {
                "name": "traits",
                "kind": "optional",
                "type": "map",
                "description": "Reference metadata to integrate with external systems like billing.\n\nThe following traits are used by Amberflo:\n- `stripeId` for [integrating with Stripe](doc:stripe);\n- `awsm.customerIdentifier` for [integrating with AWS Marketplace](doc:associating-customers-with-aws-marketplace);\n- `currency` for the customer's currency, following the ISO standard.\n",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              },
              {
                "name": "address",
                "kind": "optional",
                "type": "object",
                "description": "Tax address of the customer.",
                "modelRef": "#/components/schemas/customer.CustomerAddress.out",
                "customType": "customer.CustomerAddress.out",
                "schema": [
                  {
                    "name": "verified",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "Indicates whether the address has been validated through the address verification system.",
                    "example": ""
                  },
                  {
                    "name": "line1",
                    "kind": "required",
                    "type": "string",
                    "description": "Street address line including building number and street name.",
                    "example": ""
                  },
                  {
                    "name": "state",
                    "kind": "optional",
                    "type": "string",
                    "description": "State or province name. Required for US addresses, optional for other countries.",
                    "example": ""
                  },
                  {
                    "name": "city",
                    "kind": "required",
                    "type": "string",
                    "description": "City or municipality name where the customer is located.",
                    "example": ""
                  },
                  {
                    "name": "postalCode",
                    "kind": "optional",
                    "type": "string",
                    "description": "Postal or ZIP code for the address. Required for US addresses, optional for other countries.",
                    "example": ""
                  },
                  {
                    "name": "country",
                    "kind": "required",
                    "type": "string",
                    "description": "Country name for the customer's tax address.",
                    "example": ""
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/customer.CustomerDetails.out",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Authentication required or API key is invalid",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Insufficient permissions to access customer data",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "500",
        "description": "Internal server error occurred while retrieving customers",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "7X_KOdIF1PNbBf7-E9kBF",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request GET \\\n     --url https://app.amberflo.io/customers \\\n     --header 'accept: application/json'"
        },
        {
          "id": "NLjbJSPnRmVHzmQXBbXi2",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'GET',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://app.amberflo.io/customers\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "tFKOgUvmo1wqzuAA8bCha",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://app.amberflo.io/customers\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Get.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "NbPgaUCet2emqOeofMk_h",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://app.amberflo.io/customers\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"GET\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "7X_KOdIF1PNbBf7-E9kBF"
    },
    "results": {
      "languages": [
        {
          "id": "hFoFtv2IhJaigm9VcERRX",
          "language": "200",
          "code": "// Successfully retrieved all customer records from your account\n[\n  {\n    \"createTime\": \"\",\n    \"updateTime\": \"\",\n    \"deleteTime\": \"\",\n    \"customerId\": \"\",\n    \"customerName\": \"\",\n    \"customerEmail\": \"\",\n    \"description\": \"\",\n    \"enabled\": false,\n    \"test\": false,\n    \"lifecycleStage\": \"\",\n    \"deactivateTimeStamp\": \"\",\n    \"traits\": \"\",\n    \"address\": {\n      \"verified\": false,\n      \"line1\": \"\",\n      \"state\": \"\",\n      \"city\": \"\",\n      \"postalCode\": \"\",\n      \"country\": \"\"\n    }\n  }\n]"
        },
        {
          "id": "1ZUJKHlZrOTm6NQS-fCaA",
          "language": "401",
          "code": "// Authentication required or API key is invalid\n"
        },
        {
          "id": "baf5xGuW2XRtCJICQxVoh",
          "language": "403",
          "code": "// Insufficient permissions to access customer data\n"
        },
        {
          "id": "6GSmdcqH0_O_zXPV1UQ9a",
          "language": "500",
          "code": "// Internal server error occurred while retrieving customers\n"
        }
      ],
      "selectedLanguageId": "hFoFtv2IhJaigm9VcERRX"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}